<?php

namespace plugin\cms\controller;

use plugin\cms\model\CmsBanner;
use think\admin\Controller;
use think\admin\helper\QueryHelper;

class Banner extends Controller
{
    /**
     * 轮播图管理
     * @auth true
     * @menu true
     * @login true
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function index()
    {
        $this->title = '轮播图管理';
        CmsBanner::mQuery()->layTable(function () {
        }, static function (QueryHelper $query) {
            $query->equal('status')->like('title');
            $query->timeBetween('create_at');
        });
    }

    /**
     * 添加轮播图
     * @auth true
     * @menu true
     * @login true
     * @return void
     */
    public function add()
    {
        $this->title = '添加栏目';
        $this->_applyFormToken();
        CmsBanner::mForm('form');
    }

    /**
     * 编辑轮播图
     * @auth true
     * @menu true
     * @login true
     * @return void
     */
    public function edit()
    {
        $this->title = '编辑栏目';
        $this->id = $this->request->param('id', 0, 'intval');         //当前栏目ID
        $this->_applyFormToken();
        CmsBanner::mForm('form');
    }

    /**
     * 删除轮播图
     * @auth true
     * @menu true
     * @login true
     * @return void
     */
    public function remove()
    {
        CmsBanner::mDelete('id');
    }

    /**
     * 状态切换
     * @auth true
     * @menu true
     * @login true
     * @return void
     */
    public function status()
    {
        CmsBanner::mSave($this->_vali([
            'id.require' => '栏目ID不能为空',
            'status.in:0,1'  => '状态值范围异常！',
            'status.require' => '状态值不能为空！',
        ]), 'id');
    }

    public function sort()
    {
        CmsBanner::mSave($this->_vali([
            'id.require' => '栏目ID不能为空',
            'sort.require' => '排序值不能为空！',
            'sort.number'  => '排序必须为数字！',
            'sort.between:0,9999' => '排序值必须为0~9999之间！',
        ]), 'id');
    }
}