<?php

namespace plugin\points_mall\service;

use plugin\points_mall\model\PointsMallUserPoint;
use plugin\points_mall\model\PointsMallUserPointLog;

class UserPointService
{
    public static function getUserPoint($uid)
    {
        $point = PointsMallUserPoint::mk()->where('uid', $uid)->value('point');
        if ($point === null) {
            $point = 0;
            PointsMallUserPoint::mk()->save(['uid' => $uid, 'point' => $point]);
        }
        return $point;
    }

    public static function addUserPoint($uid, $point, $reason)
    {
        $userPoint = PointsMallUserPoint::mk()->where('uid', $uid)->find();
        if (empty($userPoint)) {
            $userPoint = PointsMallUserPoint::mk()->create(['uid' => $uid, 'point' => 0]);
        }
        $userPoint->startTrans();
        $userPoint->inc('point', $point);
        $userPoint->log()->save([
            'point' => $point,
            'reason' => $reason,
        ]);
        $userPoint->save();
        $userPoint->commit();
    }
}