<?php

namespace plugin\ticket\model;

use think\admin\Model;

class TicketTicket extends Model
{
    protected $append = ['status_text', 'type_name'];
    public function type()
    {
        return $this->belongsTo(TicketType::class, 'type_id');
    }

    public function user()
    {
        return $this->morphTo('user');
    }

    public function reply()
    {
        return $this->hasMany(TicketReply::class, 'ticket_id')->order("create_at", 'asc');
    }

    public function source()
    {
        return $this->morphTo();
    }

    public function getImgsArrAttr($value, $data)
    {
        return str2arr($data['imgs'] ?: '', '|');
    }

    public function getLastReplyAttr($value, $data)
    {
        return $this->reply()->order('create_at', 'desc')->find();
    }

    public function getTypeNameAttr($value, $data)
    {
        $type = $this->type()->find();
        if (!empty($type)) {
            return $type['name'];
        } else {
            return '未知';
        }
    }

    public function getStatusTextAttr($value, $data)
    {
        if (!empty($this->getStatusList()[$data['status']])) {
            return $this->getStatusList()[$data['status']];
        } else {
            return '未知';
        }
    }

    private function getStatusList()
    {
        return [
            -1 => '已关闭',
            0 => '待处理',
            1 => '已作处理',
        ];
    }

    public function scopeAvail($query)
    {
        return $query->where('status', '>=', '0');
    }
}